﻿@page
@using Management.Entities;
@using Management.BusinessLogic;
@model IndexModel
@{
    /* Constants */
    ViewData["Title"] = "Storage";
    const uint itemPerPage = 10;

    /* Default value */
    uint pageIndex = 1;
    uint pageTotal = 1;
    uint noStart = 1;
    uint noEnd = 1;
    uint noTotal = 1;
    string sKeyword = string.Empty;
    string sFilter = string.Empty;
    uint Filter = 0;

    /* Try get page index */
    uint.TryParse(Request.Query["page"], out pageIndex);

    /* Get filter selection */
    sFilter = Request.Query["filter"];

    if ("unexpired" == sFilter)
    {
        Filter = 1;
    }
    else if ("expired" == sFilter)
    {
        Filter = 2;
    }

    /* Get search keyword */
    sKeyword = Request.Query["search"];

    /* Read the storage list */
    Storage[] storageList = BUS_Storage.ReadList(sKeyword, Filter);

    if (storageList.Length > 0)
    {
        /* Calculate the number of pages based on the total number of products in the list */
        pageTotal = ((uint)storageList.Length - 1) / itemPerPage + 1;

        /* Check page index exceptions */
        if (pageIndex == 0 || pageIndex > pageTotal)
        {
            pageIndex = 1;
        }

        /* Calculate the Index of the products that will be displayed */
        noStart = (pageIndex - 1) * itemPerPage + 1;
        noEnd = noStart + itemPerPage - 1;
        noTotal = (uint)storageList.Length;
        if (pageIndex == pageTotal)
        {
            noEnd = noStart + ((uint)storageList.Length - 1) % itemPerPage;
        }
    }
}
<div class="row text-start">
    <p><a href="/" class="link-primary text-decoration-none">Home</a></p>
</div>
<div>
    <div class="row table_header mb-2">
        <p class="col-sm-3 mb-2 text-start fw-bold">Storage Details</p>
        <div class="col-sm-9 mb-2 text-start text-sm-end d-inline-block">
            <form method="get">
                <input type="text" id="search" name="search" value="@sKeyword" placeholder="Product Name" maxlength="30" />
                <select id="filter" name="filter">
                    @if (0 == Filter)
                    {
                        <option value="all" selected>All Products</option>
                        <option value="unexpired">Unexpired Products</option>
                        <option value="expired">Expired Products</option>
                    }
                    else if (1 == Filter)
                    {
                        <option value="all">All Products</option>
                        <option value="unexpired" selected>Unexpired Products</option>
                        <option value="expired">Expired Products</option>
                    }
                    else if (2 == Filter)
                    {
                        <option value="all">All Products</option>
                        <option value="unexpired">Unexpired Products</option>
                        <option value="expired" selected>Expired Products</option>
                    }
                </select>
                <button type="submit" value="Search" class="btn btn-sm btn-primary text-light">Search</button>
            </form>
        </div>
    </div>
    <div class="text-center table_section">
        <table class="table table-bordered table-striped table-hover align-middle">
            <thead>
                <tr>
                    <th>No</th>
                    <th>Product Name</th>
                    <th>Quantity</th>
                    <th>ManufactureDate</th>
                    <th>ExpiryDate</th>
                </tr>
            </thead>

            <tbody>
                @if (storageList.Length > 0)
                {
                    uint j = noStart - 1;
                    for (uint i = noStart; i <= noEnd; i++)
                    {
                        <tr>
                            <td>@i</td>
                            <td>@storageList[j].ProductName</td>
                            <td>@storageList[j].Quantity</td>
                            <td>@storageList[j].ManufactureDate</td>
                            <td>@storageList[j].ExpiryDate</td>
                        </tr>
                        j++;
                    }
                }
                else
                {
                    <tr>
                        <td colspan="5" class="text-center fw-bold">No data available</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>

    <div class="row table_pagination">
        @if (storageList.Length > 0)
        {
            <div class="col-3">
                <p class="pagination">From @noStart to @noEnd of @noTotal</p>
            </div>
            <div class="col-9">
                <nav aria-label="Page navigation">
                    <ul class="pagination justify-content-end">
                        @for (uint i = 1; i <= pageTotal; i++)
                        {
                            if (i == pageIndex)
                            {
                                <li class="page-item active"><a class="page-link" href="/product/?search=@sKeyword&page=@i">@i</a></li>
                            }
                            else
                            {
                                <li class="page-item"><a class="page-link" href="/product/?search=@sKeyword&page=@i">@i</a></li>
                            }
                        }
                    </ul>
                </nav>
            </div>
        }
    </div>
</div>
